<?php
/**
 * Sphider Version 5.5.*
 * Sphider is licensed under the GNU GPL.
 *
 * PHP version 5.4
 *
 * @category Sphider_Search
 * @package  Installation
 * @author   R. Prew  <CaptQ@blog.worldspaceflight.com>
 * @license  GNU GPL
 * @link     http://www.sphidersearch.com
 */
echo "<html>";
echo "<head>";
echo "<title>";
echo "Correct version number to 5.5.0.";
echo "</title>";
echo "<LINK REL=STYLESHEET HREF='admin.css' TYPE='text/css'>";
echo "</head>";
echo "<body>";
echo "<h2>Update the database version number.</h2>";

error_reporting(E_ERROR | E_DEPRECATED); //Development only
//error_reporting(0);
$settings_dir = "../settings";
require "$settings_dir/database.php";

$error = 0;
$flag = 0;


/**
 * Correct version to 5.5.0
 *
 * @return void
 */
function correct550()
{
    global $db, $mysql_table_prefix, $error, $ver;

    // Insert correct version into settings table
    $db->query(
        "UPDATE ".$mysql_table_prefix
        ."settings SET version_nr='5.5.0'
        WHERE id = 1" 
    );

    if ($db->errno > 0) {
        print "Error: ";
        print $db->error;
        print "<br>";
        $error += $db->errno;
    }

    $ver = "5.5.0";
}


$state = 0;
$result = $db->query("SHOW COLUMNS FROM `settings` LIKE 'dec_separator'");
$exists = $result->num_rows;
if ($exists == 0) {
	$state = 1;
}

if ($state == 0) {    
    $result = $db->query(
        "SELECT version_nr FROM ".$mysql_table_prefix
        ."settings WHERE id = 1"
    );
    $row = $result->fetch_row();
    if (preg_match('/5\.4\.1/', $row[0])) {
        $state = 2;
    } elseif (preg_match('/5\.5\.0/', $row[0])) {
        $state = 3;
    }
}

switch ($state) {
case 0:
case 1:
    echo "You do not have Version 5.5.0<br>No action taken.<br>";
    $flag = 1;
    break;
case 2;
    correct550();
    break;
default:
    echo "You already have the correct version number<br>";
    $flag = 1;
}

if ($error >0) {
    print "<b>Updating the database failed. Consult the above error messages.</b>";
} else {
    if (!$flag) {
        print "<b>You have successfully the version number ".$ver
          .". Go to <a href='admin.php'>admin.php</a> to start indexing.</b>"; 
    }
}

echo "</body>";
echo "</html>";
